
//  Proiect PM 2019 - Memory game
//  Elena-Miruna Gagea 336CC
// Linux, bootloaderHID, Sublime Text 2

#include <avr/io.h>
#include <avr/interrupt.h>
#define F_CPU	16000000
#include <util/delay.h>
#include <stdlib.h>


int checkButtons(int secventa[], int runda);
void levelSelector();
void buzz(int tip);
void sequenceGenerator(int secventa[], int runda);
void ledON(int led, int scurt);
void helloDance();
void winRound();

int leduri[8] = {PA0, PA1, PA2, PA3, PA4, PA5, PA6, PA7};
int NIVEL;
int secventa[9];
int butoane[8] = {PB0, PB1, PB2, PB3, PB4, PB5, PB6, PB7};

/*
 * generare secventa in functie de dificultatea aleasa
*/
void sequenceGenerator(int secventa[], int runda) {
	int i;
	for (i = 0; i < NIVEL; ++i)
		secventa[i] = (rand() + 5 * runda) % 8; //random de la tara
}

/*
 * led - led-ul care urmeaza sa fie aprins
 * scurt - 1 daca trebuie sa se aprinda scurt, 0 altfel
 */
void ledON(int led, int scurt) {
	//aprind led
	buzz(1);
	PORTA |= (1 << led);
	if(scurt == 0)
		_delay_ms(400);
	else
		_delay_ms(100);
	//sting led
	PORTA &= ~(1 << led);
	if(scurt == 0)
		_delay_ms(50);	
}


/*
 * secventa de salut care se afiseaza la pornirea jocului
*/
void helloDance() {
	//se aprind ledurile sub forma de spirala in fiecare patratel.
	buzz(0);
	_delay_ms(1000);
	PORTA = 40; 
	_delay_ms(150);
	buzz(1);
	PORTA = 60; 
	_delay_ms(150);
	buzz(1);
	PORTA = 125; 
	_delay_ms(150);
	buzz(1);
	PORTA = 255; 
	_delay_ms(150);	
	buzz(1);	
	PORTA = 0;
	
}

/**
 *functie care declanseaza sunetul buzzerului.
 tip - numarul de secunde
 */
void buzz(int tip) {
    int i;
    DDRD |= (1 << PD5);

    for (i = 0; i < tip * 50; i++) {
        PORTD ^= (1 << PD5); 
        _delay_ms(1);
    }
}

/*
 * secventa afisata pentru o runda castigata
*/
void winRound() {

	//aprindere pe diagonala a ledurilor.
	_delay_ms(500);
	PORTA = 1;
	_delay_ms(100);
	buzz(1);
	_delay_ms(100);
	PORTA = 7;
	_delay_ms(100);
	buzz(1);
	_delay_ms(100);
	PORTA = 31;
	_delay_ms(100);
	buzz(1);
	_delay_ms(100);
	PORTA = 127;
	_delay_ms(100);
	buzz(1);
	_delay_ms(100);
	PORTA = 255;
	_delay_ms(100);
	buzz(1);
	PORTA=0;
	buzz(1);
	_delay_ms(500);

	
}

/*
 * secventa[] - secventa de butoane pseudo-aleator aleasa
 * runda - runda curenta
 */
int checkButtons(int secventa[], int runda) {
	int i;
	int butoaneApasate[runda + 1];
	for (i = 0; i < runda; ++i) {
		_delay_ms(200);
		// asteptam apasarea unui buton
		do {
			_delay_ms(50);
			// daca butonul e apasat
			if ((PINB & (1 << butoane[0])) == 0) {
				// memoram ca l-am apasat
				butoaneApasate[i] = 0; 
				buzz(1);
				ledON(leduri[0], 1);
				break;
			}
			if ((PINB & (1 << butoane[1])) == 0) {
				butoaneApasate[i] = 1;
				buzz(1);
				ledON(leduri[1], 1);
				break;
			}
			if ((PINB & (1 << butoane[2])) == 0) {
				butoaneApasate[i] = 2;
				buzz(1);
				ledON(leduri[2], 1);
				break;
			}
			if ((PINB & (1 << butoane[3])) == 0) {
				butoaneApasate[i] = 3;
				buzz(1);
				ledON(leduri[3], 1);
				break;
			}
			if ((PINB & (1 << butoane[4])) == 0) {
				butoaneApasate[i] = 4;
				buzz(1);
				ledON(leduri[4], 1);
				break;
			}
			if ((PINB & (1 << butoane[5])) == 0) {
				butoaneApasate[i] = 5;
				buzz(1);
				ledON(leduri[5], 1);
				break;
			}
			if ((PINB & (1 << butoane[6])) == 0) {
				butoaneApasate[i] = 6;
				buzz(1);
				ledON(leduri[6], 1);
				break;
			}
			if ((PINB & (1 << butoane[7])) == 0) {
				butoaneApasate[i] = 7;
				buzz(1);
				ledON(leduri[7], 1);
				break;
			}
		} while(1);
	}
	// verificam apasarea butoanelor 
	for (i = 0; i < runda; ++i)
		if (butoaneApasate[i] != secventa[i])
			return 0;
	return 1;
}

/*
 * selectare nivel (1-8 niveluri posibile)
*/
void levelSelector() {
	// asteptam apasarea unui buton

	do {
		_delay_ms(20);
		if ((PINB & (1 << butoane[0])) == 0) {
			NIVEL = 2;
			buzz(1);
			ledON(leduri[0], 0);
			break;
		}
		if ((PINB & (1 << butoane[1])) == 0) {
			NIVEL = 6;
			buzz(1);
			ledON(leduri[1], 0);
			break;
		}
		if ((PINB & (1 << butoane[2])) == 0) {
			NIVEL = 3;
			buzz(1);
			ledON(leduri[2], 0);
			break;
		}
		if ((PINB & (1 << butoane[3])) == 0) {
			NIVEL = 7;
			buzz(1);
			ledON(leduri[3], 0);			
			break;
		}
		if ((PINB & (1 << butoane[4])) == 0) {
			NIVEL = 4;
			buzz(1);
			ledON(leduri[4], 0);			
			break;
		}
		if ((PINB & (1 << butoane[5])) == 0) {
			NIVEL = 8;
			buzz(1);
			ledON(leduri[5], 0);
			break;
		}
		if ((PINB & (1 << butoane[6])) == 0) {
			NIVEL = 5;
			buzz(1);
			ledON(leduri[6], 0);			
			break;
		}
		if ((PINB & (1 << butoane[7])) == 0) {
			NIVEL = 9;
			buzz(1);
			ledON(leduri[7], 0);
			break;
		}
	} while(1);
}


/*
 * functia main
*/
int main(void) {

	int i = 0;
	int runda = 0;

	// Random pentru generarea secventelor
	srand(5);

	DDRB = 0;	// selectam pinii PB pentru input
	PORTB = 255;	// activam rezitentele de pull-up pentru pinii PB
	DDRA = 255;	// selectam pinii PA pentru output
	PORTA = 0;	// LED-urile oprite initial

	helloDance();
	levelSelector();

	for (runda = 0; runda < NIVEL; ++runda) {
		sequenceGenerator(secventa, runda);
		for (i = 0; i < runda; ++i)
			ledON(leduri[secventa[i]], 0);
		if (checkButtons(secventa, runda))
			winRound();
		else {
			// joc pierdut
			_delay_ms(500);
			buzz(5);
			for (i = 0; i < 6; ++i) {
				buzz(1);
				if (i % 2 == 0) {
					PORTA = 153;
					_delay_ms(250);
					PORTA = 0;
					_delay_ms(250);
				} else {
					PORTA = 102;
					_delay_ms(250);
					PORTA = 0;
					_delay_ms(250);	
				}
			}
			_delay_ms(1000);
			exit(0);
		}
	}
	// daca nu am iesit pana acum jocul e castigat
	buzz(4);
	for (i = 0; i < 8; ++i) {
		PORTA = 255;
		buzz(3);
		_delay_ms(200);
		PORTA = 0;
		buzz(3);
		_delay_ms(200);
	}
	_delay_ms(1000);
	exit(0);
	return 0;
}

